﻿using UnityEngine;
using System.Collections;

public class Visualization : MonoBehaviour {

	public static Visualization singleton = null;
	
	public static YieldInstruction TreeUpdateYield = new WaitForSeconds(0.1f);

	public bool isRunning = false;
	public bool isPaused = true;

	// Use this for initialization
	void Start () {
		if (singleton == null) {
			singleton = this;
		}

		CanAddr cAddr = new CanAddr();
		cAddr.setTuple(1,0);
		Tile t = this.getTile(cAddr);
		t.curTemp[0] = 110f;
		t.curTemp[1] = 110f;

		cAddr.setTuple(2, 0);
		t = this.getTile(cAddr);
		t.curTemp[0] = 110f;
		t.curTemp[1] = 110f;

		cAddr.setTuple(4, 0);
		t = this.getTile(cAddr);
		t.curTemp[0] = 110f;
		t.curTemp[1] = 110f;
	}
	
	// Update is called once per frame
	void Update () {
		if (Input.GetKeyDown (KeyCode.Space)) {
			if (isPaused) {
				this.isRunning = true;
				StartCoroutine(runUpdate());
			} else {
				this.isRunning = false;
			}
		} else if (Input.GetKey(KeyCode.Escape)) {
			Application.Quit();
		}
	}

	IEnumerator runUpdate () {
		isPaused = false;
		while (isRunning) {
			updateState();
			updateProperties();
			yield return TreeUpdateYield;
		}
		isPaused = true;
	}

	private static Node rootNode = null;
	public static int propertyIndex = 0;
	
	public Tile getTile (CanAddr cAddr) {
		if (rootNode == null) { rootNode = new Node(); }
		return rootNode.getTile(cAddr);
	}
	
	public void updateState () {
		if (rootNode == null) { rootNode = new Node(); }
		rootNode.updateState();
	}
	
	public void updateProperties () {
		if (rootNode == null) { rootNode = new Node(); }
		propertyIndex = (propertyIndex + 1) % 2;
		rootNode.updateProperties();
	}
	
	public void setState (CanAddr cAddr, byte state) {
		if (rootNode == null) { rootNode = new Node(); }
		rootNode.setState(cAddr, state);
	}
}
