﻿using UnityEngine;
using System.Collections;

public class TerrainManager {

	private static float[,] terrainHeighMap;
	
	public static int terrainHeight;
	public static int terrainWidth;
	
	private static float simToTerScale = 3.0f;
	private static float terToSimScale;

	public static void initTerrainManager () {
		terToSimScale = 1 / simToTerScale;
		
		terrainHeighMap = Terrain.activeTerrain.terrainData.GetHeights (0, 0, Terrain.activeTerrain.terrainData.heightmapWidth, Terrain.activeTerrain.terrainData.heightmapHeight);
		terrainHeight = Terrain.activeTerrain.terrainData.heightmapHeight;
		terrainWidth = Terrain.activeTerrain.terrainData.heightmapWidth;
	}

	// NOTE: This function expects incoming position to be in "Terrain Coordinates"
	// TODO: If I care & have time, have the returned height value be interpolated between integer values
	public static float getHeightForPos (Vector2 pos) {
		int posX = Mathf.RoundToInt(pos.x);
		int posY = Mathf.RoundToInt(pos.y);
		return terrainHeighMap[posX, posY];
	}
	
	public static Vector2 convertSimToTerrain (Vector2 simCoords) {
		Vector2 result = new Vector2 (terrainWidth/2, terrainHeight/2);
		result += (simCoords * simToTerScale);
		return result;
	}
	
	public static Vector2 convertTerrainToSim (Vector2 terCoords) {
		Vector2 result = new Vector2(terCoords.x - (terrainWidth/2), terCoords.y - (terrainHeight/2));
		result *= terToSimScale;
		return result;
	}
}
